mysite/blog/urls.py
from django.urls import path
from .views import PostListView, PostDetailView
from . import views

app_name = 'blog'

urlpatterns = [
    # path('',views.post_list, name='home'),
    path('',PostListView.as_view(), name='home'),
    # path('<int:pk>/<slug:slug>/', views.post_detail, name='detail'),
    path('<int:pk>/<slug:slug>/', PostDetailView.as_view(), name = 'detail'),
    path('category/<slug:slug>/',views.post_by_category,name='post_by_category'),
    path('tag/<slug:slug>/', views.post_by_tag, name = 'post_by_tag'),
    path('blog/',views.test_redirect, name = 'test_redirect'),
    path('feedback/',views.feedback, name = 'feedback'),

]

mysite/cadmin/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth_views
from .views import PostCreateView, PostUpdateView, PostDeleteView


app_name = 'cadmin'

urlpatterns = [
    path('activate/account/', views.activate_account, name = 'activate'),
    path('register/', views.register, name = 'register'),
    path('login/', auth_views.LoginView.as_view(template_name = 'cadmin/login.html'), name = 'login'),
    path('logout/', auth_views.LogoutView.as_view(template_name = 'cadmin/logout.html'), name = 'logout'),
    path('profile/',views.profile,name= 'profile'),
    # path('post/add/',views.post_add,name= 'post_add'),
    path('post/add/', PostCreateView.as_view(),name = 'post-create'),
    # path('post/update/<int:pk>/', views.post_update, name = 'post_update'),
    path('post/update/<int:pk>/', PostUpdateView.as_view(), name = 'post-update'),
    path('post/delete/<int:pk>/', PostDeleteView.as_view(), name = 'post-delete')



]

mysite/cadmin/models.py
from django.db import models

# Create your models here.

mysite/cadmin/forms.py
from django import forms
from django.contrib.auth.models import User
from blog.models import Author
from django.contrib.auth.forms import UserCreationForm


class UserRegisterForm(UserCreationForm):
    email = forms.EmailField()

    class Meta:
        model = User

        fields = ['username', 'email', 'password1', 'password2']

class UserUpdateForm(forms.ModelForm):
    class Meta:
        email = forms.EmailField()

    class Meta:
        model = User
        fields = ['username', 'email']

class ProfileUpdatForm(forms.ModelForm):
    class Meta:
        model = Author
        fields = ['pp']

mysite/cadmin/views.py
from django.shortcuts import render, redirect, get_object_or_404, reverse, Http404
from blog.forms import PostForm
from blog.models import Post, Author, Category, Tag
from django.contrib import messages
from django.conf import settings
from blog.urls import urlpatterns
from . forms import UserRegisterForm, ProfileUpdatForm, UserUpdateForm
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.core.mail import send_mail
from mysite import helpers
from django.views.generic import CreateView, UpdateView, DeleteView
# Create your views here.
def register(request):
    if request.method == 'POST':

        form = UserRegisterForm(request.POST)
        if form.is_valid():
            activation_key = helpers.generate_activation_key(username = request.POST['username'])
            subject = 'Django Blog Account Activation'
            message = f'''\n
            please cluck on the link below to activate your account: \n
            {request.scheme}://{request.get_host()}/cadmin/activate/account/?key={activation_key}
            '''
            error = False
            try:

                send_mail(subject, message, settings.SERVER_EMAIL, [request.POST['email']])
                messages.success(request,f'Account created! Click on the link sent to your email to activate the account')
            except:
                error = True
                messages.success(request,'Unable to send email. Please try again')
            
            if not error:
                u = User.objects.create_user(request.POST['username'],
                                            request.POST['email'],
                                            request.POST['password1'],
                                            is_active = 0)
                author = Author()
                author.activation_key = activation_key
                author.user = u
                author.save()

            
            return redirect('cadmin:register')
    else:
        form = UserRegisterForm()
    return render(request, 'cadmin/register.html', {'form':form})


def activate_account(request):
    key = request.GET['key']
    if not key:
        raise Http404()

    r = get_object_or_404(Author, activation_key=key, email_validated=False)
    r.user.is_active = True
    r.user.save()
    r.email_validated = True
    r.save()

    return render(request, 'cadmin/activated.html')

    
@login_required
def profile(request):
    if request.method == 'POST':
        
        u_form = UserUpdateForm(request.POST,instance=request.user)
        p_form = ProfileUpdatForm(request.POST,
                                    request.FILES,
                                    instance=request.user.author)
        if u_form.is_valid() and p_form.is_valid():
            u_form.save()
            p_form.save()
            messages.success(request, 'Profile Updated!')
            return redirect(reverse('cadmin:profile'))

    else:
        if request.user.is_staff:
            return render(request, 'cadmin/profile.html')
        else:

            u_form = UserUpdateForm(instance=request.user)
            p_form = ProfileUpdatForm(instance=request.user.author)
        

            context = {
                        'u_form':u_form,
                        'p_form':p_form
                        }
            return render(request, 'cadmin/profile.html',context)



# @login_required
# def post_add(request):
#     if request.method == 'POST':
#         # creating a bound form with form data
#         f = PostForm(request.POST) 

#         if f.is_valid():
#             f.save()
#             messages.add_message(request, messages.SUCCESS,'Post Added!')
#             return redirect('cadmin:post_add')
#     else:
#         # show unbound form to user
#         f = PostForm()

#         return render(request, 'cadmin/post_add.html',{'form':f})

#Post CreateView
class PostCreateView(LoginRequiredMixin, CreateView):

    model = Post
    template_name = 'cadmin/post_form.html'
    fields = ['title', 'content','category','tags']
    def form_valid(self,form):
        form.instance.author = Author.objects.get(user = self.request.user)
        return super().form_valid(form)



# @login_required
# def post_update(request, pk):
#     post = get_object_or_404(Post, pk = pk)

#     if request.method == 'POST':
#         f = PostForm(request.POST, instance=post)
#         if f.is_valid():
#             f.save()
#             messages.add_message(request, messages.INFO,'Post Updated!')
#             return redirect(reverse('cadmin:post_update', args=[post.pk]))
#     else:
#         f = PostForm(instance=post)
#         return render(request,'cadmin/post_update.html', {'form':f,'post':post})

#PostUpdateView
class PostUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):

    model = Post
    template_name = 'cadmin/post_form.html'
    fields = ['title', 'content','category','tags']
    def form_valid(self,form):
        form.instance.author = Author.objects.get(user = self.request.user)
        return super().form_valid(form)

    def test_func(self):
        post  = self.get_object()
        a = Author.objects.get(user = self.request.user)
        
        if a == post.author:

            return True
        return False


#PostDetailView


class PostDeleteView(LoginRequiredMixin, UserPassesTestMixin,DeleteView):
    model = Post
    success_url = '/'
    template_name = 'cadmin/post_confirm_delete.html'
    def test_func(self):
        post  = self.get_object()
        a = Author.objects.get(user = self.request.user)
        
        if a == post.author:
            return True
        return False

mysite/templates/cadmin/activated.html
{% extends 'base.html'%}

{%block content%}
    <h2>Account Activated</h2>

    <div class="border-top pt-3">
        <small class="text-muted">Click 
            <a class="ml-2" href="{%url 'cadmin:login'%}">here</a> 
            to login
            
        </small>
    </div>


{% endblock%}

mysite/templates/cadmin/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{% block title %}The Great Django Blog :: Admin Panel{% endblock %}</title>
    
    <!-- Compiled and minified JavaScript -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
    <script>
      $(document).ready(function(){
        $('select').formSelect();
      });
    </script>
    <!-- Compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <!-- Google fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
</head>
<body>

    {% block content %}

    {% endblock %}

    
</body>
</html>

mysite/templates/cadmin/base_admin.html
{% extends "cadmin/base.html" %}

{% block content %}

   <nav>
    <div class="container nav-wrapper">
        <a href="" class="brand-logo">The Great Django Blog - Admin Panel</a>
    </div>
   </nav>
    
    

    
    <ul id = "slide-out" class="sidenav sidenav-fixed">
        <li><div class="user-view">
            <div class="background">
                {% load static %}
              <img src='{% static "images/office.jpg" %}'>
            </div>
            <a href="{%url 'cadmin:profile'%}"><img class="circle" src="{{ request.user.author.pp.url }}"></a>
            <a href="{%url 'cadmin:profile'%}"><span class="white-text name">{{ request.user.username}}</span></a>
            <a href="{%url 'cadmin:profile'%}"><span class="white-text email">{{ request.user.email}}</span></a>
          </div></li>
        <li><a href="">Post</a></li>
        <li><a href="">Category</a></li>
        <li><a href="">Tag</a></li>
        <li><a href="">Change Password</a></li>
        <li><a target="_blank" href="{%url 'blog:home'%}">View Site</a></li>
        {% if request.user.is_staff %}
        <li><a target="_blank" href="{%url 'admin:index'%}">Admin Panel</a></li>
        {%endif%}
        <li><a href="{%url 'cadmin:logout'%}">Logout</a></li>
    </ul>
    

            {% block main %}

            {% endblock %}

        

    

{% endblock %}

mysite/templates/cadmin/login.html
{% extends 'base.html'%}
{% load crispy_forms_tags %}
{% block content %}
<form method="POST">
    {% csrf_token %}
    <fieldset class="form-group">
        <legend class="border-bottom mb-4">Login</legend>
        {{form|crispy}}
    </fieldset>
    <div class="form-group">
        <button class="waves-effect waves-light btn-large" type="submit">Login</button>
    </div>
</form>
<div class="border-top pt-3">
    <small class="text-muted">Don't have an account?
        <a class="ml-2" href="{%url 'cadmin:register'%}">Register</a>
    </small>
</div>

{% endblock %}

mysite/templates/cadmin/logout.html
{% extends 'base.html'%}

{%block content%}
    <h2>You have been logged out</h2>

    <div class="border-top pt-3">
        <small class="text-muted">Login again
            <a class="ml-2" href="{%url 'cadmin:login'%}">Sign In</a>
        </small>
    </div>


{% endblock%}

mysite/templates/cadmin/post_add.html
{% extends 'cadmin/base_admin.html'%}
{% load crispy_forms_tags %}
{% block title %}
    Add New Post - {{ block.super }}
{% endblock %}

{% block main %}
    {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{%if message.tags %} class = "{{ message.tags }}" {% endif %}>{{message }}</li>
            {% endfor %}
        </ul>
    {% endif%}
    <div class="container">
        <p>&#187; <a href="">All Posts</a> &#187; Add Post</p>

        <h3>Add Post</h3>
        <form action="" method="POST">
            {% csrf_token %}
            
                {{ form.as_p }}
                
               
                <div class="form-group">
                    <button class="waves-effect waves-light btn-large" type="submit">Post</button>
                </div>

        </form>
    </div>

{% endblock %}

mysite/templates/cadmin/post_confirm_delete.html
{% extends 'cadmin/base_admin.html'%}
{% load crispy_forms_tags %}
{% block title %}
    Post - {{ block.super }}
{% endblock %}

{% block main %}
    {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{%if message.tags %} class = "{{ message.tags }}" {% endif %}>{{message }}</li>
            {% endfor %}
        </ul>
    {% endif%}
    <div class="container">
        
        <form action="" method="POST">
            {% csrf_token %}
            
                <h2>Are you sure that you want to delete the post "{{ object.title}}"</h2>
               
                <div class="form-group">
                    <button class="waves-effect waves-light btn-large btn-danger" type="submit">Yes, Delete</button>
                    <a class="waves-effect waves-light btn-large btn-secondary" href="{{object.get_absolute_url}}">Cancel</a>

                </div>

        </form>
    </div>

{% endblock %}

mysite/templates/cadmin/post_form.html
{% extends 'cadmin/base_admin.html'%}
{% load crispy_forms_tags %}
{% block title %}
    Post - {{ block.super }}
{% endblock %}

{% block main %}
    {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{%if message.tags %} class = "{{ message.tags }}" {% endif %}>{{message }}</li>
            {% endfor %}
        </ul>
    {% endif%}
    <div class="container">
        

        
        <form action="" method="POST">
            {% csrf_token %}
            
                {{ form.as_p}}
               
                <div class="form-group">
                    <button class="waves-effect waves-light btn-large" type="submit">Post</button>
                </div>

        </form>
    </div>

{% endblock %}

mysite/templates/cadmin/post_update.html
{% extends 'cadmin/base_admin.html'%}

{% block title %}
    Update Post - {{block.super}}
{% endblock %}

{% block main %}
    <div class="container">
        <p>&#187; <a href="">All Posts</a>&#187; Post Update</p>

        <h3>Post Update</h3>
        {% if messages %}
        <ul class="messages">
            {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
            {% endfor %}
        </ul>
        {% endif %}
        <form action="" method="POST">
            {% csrf_token %}
            <table>
                {{ form.as_table }}
                <tr>
                    <td></td>
                    <td><input type="submit" value = 'Updte Post'></td>
                </tr>
            </table>

        </form>
    </div>


{% endblock %}

mysite/templates/cadmin/profile.html
{% extends 'cadmin/base_admin.html'%}
{% load crispy_forms_tags %}
{% block title %}
    Profile - {{ block.super }}
{% endblock %}

{% block main %}

    <div class="container">
        {% if messages %}
        <ul class="messages">
            {% for message in messages %}
            <li{%if message.tags %} class = "{{ message.tags }}" {% endif %}>{{message }}</li>
            {% endfor %}
        </ul>
    {% endif%}
        {% if request.user.is_staff %}
        <p>{{ user.username }}</p>
        {% else%}
        <form method="POST" enctype = "multipart/form-data"> 
            {% csrf_token %}
            <fieldset class="form-group">
                <legend class="border-bottom mb-4">Profile Info</legend>
                {{u_form|crispy}}
                <div>
                    {{p_form.as_p}}
                </div>
                
            </fieldset>
            <div class="form-group">
                <button class="waves-effect waves-light btn-large" type="submit">Update</button>
            </div>
        </form>
        {%endif%}
    </div>
    

{% endblock %}

mysite/templates/cadmin/register.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block content %}
{% if messages %}
{% for message in messages %}
    <div class="alert-{{message.tags}}">
        {{message}}
    </div>
{% endfor %}
{% endif %}
    <form method="POST">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Join Today!</legend>
            {{form|crispy}}
        </fieldset>
        <div class="form-group">
            <button class="waves-effect waves-light btn-large" type="submit">Sign Up</button>
        </div>
    </form>
    <div class="border-top pt-3">
        <small class="text-muted">Already have an account?
            <a class="ml-2" href="{%url 'cadmin:login'%}">Sign In</a>
        </small>
    </div>


{% endblock %}